<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>7 tools for visualizing a codebase</title>
    <link href="style.css" rel="stylesheet">
</head>
<body>
<header>
    <h1>
        7 tools for visualizing a codebase
    </h1>
</header>
<div>
    <p> Need to write a README file, but not sure what to say? If this is a frustration that bothers you frequently, you might consider beefing your document up with a diagram. After all, a picture is worth a thousand words, as the cliche goes.
    </p>

    <img src="img/pic1.jpg" alt="neponyatni rysochku">
    <p>
        <small>
            Photo by <a href="https://unsplash.com/@hcmorr?utm_source=unsplash&utm_medium=referral&utm_content=creditCopyText" target="_blank">Hanna Morris</a>
            on <a href="https://unsplash.com/s/photos/diagram?utm_source=unsplash&utm_medium=referral&utm_content=creditCopyText" target="_blank">Unsplash</a>
        </small>
    </p>
</div>
<div>
    <p> This article collects tools that generates graphs for a code repository.</p>
    <h2>Visualize files by size and type
    </h2>
    <p>
        Let’s <b>start with the most generic</b> tool, <a href="https://github.com/githubocto/repo-visualizer" target="_blank"> repo-visualizer.</a> It plots files as bubbles, indicating their extension names and sizes with colors and sizes, respectively. It's <a href="https://next.github.com/projects/repo-visualization/" target="_blank">brought to you</a> by
        <a href="https://next.github.com/" target="_blank">GitHub Next</a>, a lab at GitHub the company, and (naturally) it's packaged as a <a href="https://github.com/features/actions" target="_blank">GitHub Action</a>.
    </p>

    <h2>Visualize Docker Compose files
    </h2>
    <p>
        The next tool specifically caters to Docker users, but it’s still language-agnostic. To visualize docker-compose.yml, you can use <a href="https://github.com/pmsipilot/docker-compose-viz" target="_blank">docker-compose-viz</a>:
    </p>
    <span> docker run \--rm \-it \--name dcv \-v $(pwd):/input pmsipilot/docker-compose-viz render \-m image docker-compose.yml
    </span>
    <p> Here’s how it would look:
    </p>
    <img src="img/pic2.png" alt="shema">
    <p> I like how it’s also plotting extra information like open ports and mounted volumes.</p>
</div>

<div>
    <h2>Visualize <a href="https://en.wikipedia.org/wiki/Call_graph">call graphs</a>
    </h2>
    <p>
        <a href="https://github.com/scottrogowski/code2flow" target="_blank">Code2flow</a> supports a couple of <b>dynamic</b> languages, including Python, JavaScript, Ruby, and PHP.
        <br>Here’s the example provided in its README:
    </p>
    <span> code2flow code2flow/engine.py code2flow/python.py --target-function=code2flow --downstream-depth=3
</span>
    <img src="img/pic3.png" alt="shema_zi_strelochkamu">
    <p> If <b>Python</b> is the only language you care about, you might have heard of <a href="https://github.com/gak/pycallgraph" target="_blank"> pycallgraph </a>, but -- alas, the bane of open source software projects -- the original author had to abandon the project due to personal time constraints. The most sensible <b>alternative</b> I can find is <a href="https://github.com/davidfraser/pyan" target="_blank">pyan</a>.
    </p>
    <span> pyan *.py --uses --no-defines --colored --grouped --annotated --svg >myuses.svg
    </span>
    <img src="img/pic4.png" alt="big shema">
</div>
<div>
    <h2>Visualize dependencies
    </h2>
    <p>
        A fundamental functionality of build systems and package managers is dependency resolution. As you’d expect, many visualization tools tap into dependency graphs generated by these software to plot diagrams for a repository. <br> Under the hood, most of these tools use graphviz for the actual plotting work. Therefore, don't be surprised to discover that the diagrams share a similar style.
        <br> <a href="https://bazel.build/" target="_blank">Bazel</a> is a language-agnostic build system. The developers behind <b>Bazel</b> know its users so well that they put up an <a href="https://blog.bazel.build/2015/06/17/visualize-your-build.html" target="_blank">official guide</a> for visualizing dependencies defined with Bazel:
    </p>
    <span>bazel query 'deps(//:main)' --output graph > dependencies.in
dot -Tpng < dependencies.in > dependencies.svg
    </span>
    <p>It gives something like this:
    </p>
    <img src="img/pic5.png" alt="lil shema z 4 kvadratix">
    <p> For <b>Python</b> packages in an environment, use <a href="https://pypi.org/project/pipdeptree/" target="_blank">pipdeptree</a>:
    </p>
    <span> pipdeptree --graph-output svg > dependencies.svg
    </span>
    <img src="img/pic6.png" alt="middle shema">
    <p>For <b>Java</b> projects built with <a href="https://maven.apache.org/" target="_blank">Maven</a>, depgraph-maven-plugin is the way to go:
    </p>
    <span>
        mvn com.github.ferstl:depgraph-maven-plugin:graph
    </span>
    <img src="img/pic7.png" alt="last shema">
</div>
<div>
    <h2> I want more interactivity!
    </h2>
    <p> Maybe you’re not here to fill up your README; rather, you just want to learn about a repo as quickly and intuitively as possible. If that’s the case, there are some nice tools you can play with:
    </p>
    <ul>
        <li><a href="https://gource.io/">Gource</a>: A locally-run software. </li>
        <li><a href="https://www.codesee.io/">CodeSee</a>: A cloud service that offers paid plans.</li>
    </ul>
    <p> I’m not endorsing either of them, and they are beyond the scope of this post. Nevertheless, this serves as a good point to wrap up this post. Writing an ending is painful, and I’m sure you’re aware of that — Otherwise, you would not have landed on this very article that helps you evade the chore of composing words, would you?
    </p>


</div>



</body>
</html>